<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Core\Handler;

use Slim\Handlers\NotAllowed as SlimNotAllowed;

class NotAllowed extends SlimNotAllowed
{
    use HandlerTrait;

    /**
     * Not Allowed メッセージを返す
     *
     * @param array $methods
     * @return string
     */
    protected function renderHtmlNotAllowedMessage($methods)
    {
        $allow = implode(', ', $methods);

        $title = '許可されていないメソッドです';
        $html = '<main><article>'
            . '<h2>詳細</h2>'
            . '<p>メソッドは次のいずれかである必要があります： <strong>' . e($allow) . '</strong></p>'
            . '</article></main>';

        return $this->renderTemplate($title, $html);
    }
}
