<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Core\Queries;

use Interop\Container\ContainerInterface;

abstract class Query
{
    /**
     * @var ContainerInterface
     */
    protected $c;

    /**
     * @param ContainerInterface $c
     */
    public function __construct(ContainerInterface $c)
    {
        $this->c = $c;
    }

    /**
     * @param array $config
     * @param array $params
     * @return mixed
     */
    abstract public function __invoke(array $config, array $params = []);

    /**
     * GETパラメータ取得
     *
     * @return mixed
     */
    protected function getQueryParams()
    {
        return $this->c->request->getQueryParams();
    }

    /**
     * POSTデータ取得
     *
     * @return mixed
     */
    protected function getParsedBody()
    {
        return $this->c->request->getParsedBody();
    }

    /**
     * GET/POSTデータ取得
     *
     * @param array|null $only
     * @return mixed
     */
    protected function getParams(array $only = null)
    {
        return $this->c->request->getParams($only);
    }
}
