<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Site\Middleware;

use Psr\Http\Message\ResponseInterface;
use MicroEngine\Core\Middleware\Middleware;
use Psr\Http\Message\ServerRequestInterface;

class EditLinkMiddleware extends Middleware
{
    /**
     * @param  ServerRequestInterface $request
     * @param  ResponseInterface $response
     * @param  callable $next
     * @return ResponseInterface
     */
    public function __invoke(ServerRequestInterface $request, ResponseInterface $response, callable $next): ResponseInterface
    {
        $response = $next($request, $response);

        // ログインしている場合は、ページ編集画面へのリンクを挿入する
        if ($this->c->auth->authenticated()) {
            $body = $response->getBody();
            $pageId = $this->c->site->getId();
            if ($body->isWritable() && $pageId) {
                $editLink = $this->c->view->fetch('cms/views/partials/editLink.twig', compact('pageId'));
                $editLink .= "</body>";

                $body->rewind();
                $html = $body->getContents();
                $html = str_ireplace('</body>', $editLink, $html);
                $body->rewind();
                $body->write($html);
            }
        }
        return $response;
    }
}
